unit Unit1; 
{ ce programme APE2009 réalisé avec le logiciel libre Lazarus v0.9.27 beta (sous LINUX Ubuntu 9.04)
fait suite à celui nommé APE2008 programmé sous Delphi.
Il est compatible avec les données copiées dans le logiciel Cartes du Ciel (Skychart) version 3.1 svn 2009

Ce programme interprete le texte de la boite "Identification" du logiciel 'Cartes du Ciel' version Linux
de Patrick Chevallet
Les données doivent être importées par le presse papier avec le bouton "copier tout"
de la boite popup "Au sujet de..." qui s'ouvre lors d'un clic droit sur un objet dans
le logiciel 'Cartes du Ciel' de Patrick Chevallet.

Patrick Chevallet, que je remercie au passage pour son logiciel Cartes du Ciel,
n'est en aucune manière responsable de ce proggramme (APE2009), encore moins des bugs éventuels.

Ce logiciel est libre sous copyleft GNU GPL
L'objectif de la licence GNU GPL, selon ses créateurs est de garantir à l'utilisateur les droits suivants (appelés libertés) sur un programme informatique :
1. La liberté d'exécuter le logiciel, pour n'importe quel usage ;
2. La liberté d'étudier le fonctionnement d'un programme et de l'adapter à ses besoins, ce qui passe par l'accès aux codes sources ;
3. La liberté de redistribuer des copies ;
4. La liberté d'améliorer le programme et de rendre publiques les modifications afin que l'ensemble de la communauté en bénéficie.
(source Wikipédia)

Silicium628
}

{ ==============================================================================
 NOTES DE VERSIONS:
 -depuis la version 3.6 : liaison série 19200 Baud au lieu de 9600 Baud
 ==============================================================================}

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Menus, ExtCtrls, Grids, Buttons, Spin, ActnList,{ FileCtrl,}
  serial, IBConnection, Unit2, Unit_variables, Printers, ComCtrls,
  PrintersDlgs, Process;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBt_copie_in_grille: TBitBtn;
    BitBtn_DOWN: TBitBtn;
    BitBt_UP: TBitBtn;
    Bt_import_CdC: TButton;
    Button1: TButton;
    Button10: TButton;
    Button2: TBitBtn;
    Button3: TBitBtn;
    Button4: TBitBtn;
    Button5: TBitBtn;
    Button6: TBitBtn;
    Button7: TBitBtn;
    Button8: TBitBtn;
    Button9: TButton;
    Edit5: TEdit;
    Mode: TMenuItem;
    Edit14: TEdit;
    Led_USB1: TShape;
    Memo3: TMemo;
    AffichageEtendu: TMenuItem;
    Aide: TMenuItem;
    Aide_liaison_serie: TMenuItem;
    Ecrire_plusieurs_objets: TMenuItem;
    Imprimer: TMenuItem;
    aide_generale: TMenuItem;
    A_propos: TMenuItem;
    MenuClose: TMenuItem;
    MenuOpen: TMenuItem;
    MenuPortSerie: TMenuItem;
    Stop: TMenuItem;
    PrintDialog1: TPrintDialog;
    Cbox_Constellations: TComboBox;
    Edit1: TEdit;
    Edit20: TEdit;
    Edit11: TEdit;
    Edit13: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit10: TEdit;
    Edit4: TEdit;
    Edit7: TEdit;
    Edit9: TEdit;
    Edit8: TEdit;
    Edit6: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    Fichier: TMenuItem;
    Enregistrer: TMenuItem;
    Charger: TMenuItem;
    EEPROM: TMenuItem;
    ecrire_EEPROM: TMenuItem;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    ProgressBar1: TProgressBar;
    Radio_Tri: TRadioGroup;
    SaveDialog1: TSaveDialog;
    Led_USB2: TShape;
    StringGrid2: TStringGrid;
    Timer4_WriteRS232: TTimer;
    ToggleBt1: TToggleBox;
    UpDown1: TSpinEdit;
    StringGrid1: TStringGrid;
    procedure AffichageEtenduClick(Sender: TObject);
    procedure aide_generaleClick(Sender: TObject);
    procedure Aide_liaison_serieClick(Sender: TObject);
    procedure A_proposClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn_DOWNClick(Sender: TObject);
    procedure BitBt_UPClick(Sender: TObject);
    procedure Bt_import_CdCClick(Sender: TObject);
    procedure BitBt_copie_in_grilleClick(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure ChargerClick(Sender: TObject);
    procedure ecrire_EEPROMClick(Sender: TObject);
    procedure Ecrire_plusieurs_objetsClick(Sender: TObject);
    procedure Edit10EditingDone(Sender: TObject);
    procedure Edit13Change(Sender: TObject);
    procedure Edit9EditingDone(Sender: TObject);
    procedure EnregistrerClick(Sender: TObject);
    procedure FormClose(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImprimerClick(Sender: TObject);
    procedure MenuCloseClick(Sender: TObject);
    procedure MenuOpenClick(Sender: TObject);
    procedure Port_serieClick(Sender: TObject);
    procedure recopie_1ligne_dans_cadre(num_ligne:integer);
    procedure StopClick(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure StringGrid1_up;
    procedure StringGrid1_down;
    procedure StringGrid1_tri_numerique(col_i:integer);
    procedure StringGrid1_trier(col_i:integer);
    procedure StringGrid1_calcul_distance;
    procedure detecte_expression(txti:string; L:integer);
    procedure Decoder_CdC;
    procedure Affiche_RA_sexa(nb_secondes: integer);
    procedure Affiche_DECLI_sexa(nb_secondes: integer);
    procedure constitution_message(num_objet:integer);
    procedure EditClick(Sender: TObject);
    procedure decodage_abrev_constell;
    procedure efface_cadre_saisie;
    procedure Envoi_Message(cmd:string);
    procedure PrintGrid(SGrid: TStringGrid; nb_lignes: integer);
    procedure EnfonceBouton(n:integer);
    procedure StringGrid1_top;
    procedure StringGrid1_bottom;
    procedure Charger_fichier(nom_fichier1:string);
    procedure Timer4_WriteRS232Timer(Sender: TObject);
    procedure WR_EEPROMClick(Sender: TObject);
    procedure encode_RA;
    procedure encode_DEC;

  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

const
  nbr_ast= 200;
  nb_caract_232=40;
  largeur_mini=710;
  largeur_maxi=1025;

var
  RS232Buffer_out:array[1..50*nb_caract_232] of byte;
  objet_valide: boolean;
  version_i:string;
  CurrentRept:string;
  nom_Objet:string;
  nom_cstl:string;
  message1:string;
  num_objet:integer;
  RA, DECLI:integer;
  RAih,RAimn,RAis:integer;
  DECid,DECimn,DECis:integer;
  signeD:char;
  txt_RA, txt_DECLI: string;
  AProcess: TProcess;


{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
 i:byte;
begin
// CurrentRept:=GetExePath;
 Timer4_WriteRS232.Enabled:=false;
 version_i:='v3.6';
 form1.caption:='APE2009 - Importation d''objets - ' +version_i ;
 port_serie_ouvert:=false;
 choix_port_serie_ok:=false;
// nb_lect:=0;

// st1:='00' + IntToStr(UpDown1.Value);
// st1t:= copy(st1, length(st1) -1, 2);

 StringGrid1.ColWidths[0]:= 40;   // num (grise)
 StringGrid1.ColWidths[1]:= 80;   StringGrid1.Cells[1,0]:= 'Objet';
 StringGrid1.ColWidths[2]:= 50;   StringGrid1.Cells[2,0]:= 'RA';
 StringGrid1.ColWidths[3]:= 55;   StringGrid1.Cells[3,0]:= 'DECLI';
 StringGrid1.ColWidths[4]:= 35;   StringGrid1.Cells[4,0]:= 'Cstl';
 StringGrid1.ColWidths[5]:= 35;   StringGrid1.Cells[5,0]:= 'Mv';
 StringGrid1.ColWidths[6]:= 40;   StringGrid1.Cells[6,0]:= 'num';
 StringGrid1.ColWidths[7]:= 60;

 AffichageEtendu.Checked:=false;

 StringGrid2.ColWidths[0]:= 30;
 StringGrid2.ColWidths[1]:= 240;

 Form1.Height:=670;

 Memo3.Visible:=false;
 Form1.Width:=largeur_mini;

// Form1.Width:=largeur_maxi;
// Memo3.Visible:=true;

 For i:=1 to 200 do
  begin
   StringGrid1.Cells[0,i]:= IntToStr(i);
  end;
 objet_valide:=false;

 num_objet:=0;

 //scrutation:=true;
 EnfonceBouton(0);
 fichier_etoiles_ok := false;
 Charger_fichier(CurrentRept + 'etoiles/default.etl');
end;


procedure TForm1.PrintGrid(SGrid: TStringGrid; nb_lignes: integer);
// procedure fonctionne ok mais ne trace pas le quadrillage du stringGrid
var
 hPrinter   : TPrinter;
 X1, X2 : Integer;
 Y1, Y2 : Integer;
 TmpI : Integer;
 col : Integer;
 rect1 : TRect;
 x,y:integer;
begin

 if PrintDialog1.Execute then
 begin
   hPrinter := Printer;
   hPrinter.BeginDoc;
   with hPrinter.Canvas do
   begin
     Pen.Color:=1;
     Pen.Width:= 2;
     Font.Color:= clBlack;
     Font.Name:='Courrier New';
     Font.Size:=10;
     TextOut(100, 100, 'Liste d''objets pour APE2009');
     For col:=0 to SGrid.ColCount-1  do
     begin
       X1:=0;
       For TmpI:=0 to (col-1) do X1:=X1+5*(SGrid.ColWidths[TmpI]);
       Y1:=30;
       X2:=0;
       For TmpI:=0 to col do X2:=X2+5*(SGrid.ColWidths[TmpI]);

       Y2:=450;
       rect1:=Rect(X1, Y1, X2-30, Y2);
       Font.Style:=[fsBold];
       Font.Size:=7;
       TextRect(rect1, X1+50, 350, SGrid.Cells[col, 0]);
       Font.Style:=[];

       x:=20;
       if nb_lignes > SGrid.RowCount-1 then nb_lignes:=SGrid.ColCount-1;
       For TmpI:=1 to nb_lignes do
       begin
         Y1:=50*TmpI+300;
         Y2:=50*(TmpI+1)+300;
         rect1:=Rect(X1, Y1, X2-300, Y2);
         TextRect(rect1, X1+50, Y1+50, SGrid.Cells[col, TmpI]);
         y:=Y2;
         MoveTo(x,y);
         LineTo(x+1600,y);  // ligne horizontale
       end;
       y:=Y2+50;
       MoveTo(x,y);
       LineTo(x+1600,y); // dernière ligne horizontale à la fin
     end;
 hPrinter.EndDoc;

 end;
 end;
end;


 procedure TForm1.ImprimerClick(Sender: TObject);
 begin
 //imprime les 50 premières lignes du tableau StringGrig1 destinées à la raquette APE2009
  PrintGrid(StringGrid1,50);
 end;




procedure TForm1.StringGrid1Click(Sender: TObject);
var
 num_objet:integer;
begin
  num_objet:= StringGrid1.Row;
  UpDown1.Value:=num_objet;
  constitution_message(num_objet);

  if ToggleBt1.Checked then recopie_1ligne_dans_cadre(StringGrid1.Row);
end;

procedure TForm1.StringGrid1_top;
// déplace la ligne en tête de la liste
  var
  r,i,select:integer;
  S: array[1..6] of string;
 begin
  with StringGrid1 do
  begin
   if Row<2 then exit;
   select:=row;
   for i:=1 to 6 do S[i]:=cells[i,select];  //memorise la ligne sélectionnée

// descend toutes les lignes entre la 1 et celle sélectionnée d'une ligne.
   for r:=select downto 2 do  for i:=1 to 6 do  cells[i,r]:= cells[i,r-1];
   for i:=1 to 6 do cells[i,1]:= S[i]; //deplace la ligne mémorisée vers la première ligne
  end;
end;


procedure TForm1.StringGrid1_bottom;
// déplace la ligne après les 50 premiers (c'est à dire en 51eme position)
  var
  r,i,select:integer;
  S: array[1..6] of string;
 begin
  with StringGrid1 do
  begin
   if Row>50 then
   begin
    showmessage('Cette fonction ne concerne pas les lignes > 50');
    exit;
   end;
   select:=row;
   for i:=1 to 6 do S[i]:=cells[i,select];  //memorise la ligne sélectionnée

// monte toutes les lignes entre la 51 et celle sélectionnée d'une ligne.
   for r:=select to 51 do  for i:=1 to 6 do  cells[i,r]:= cells[i,r+1];
   for i:=1 to 6 do cells[i,51]:= S[i]; //deplace la ligne mémorisée vers la ligne 51
  end;
end;

 procedure TForm1.StringGrid1_up;
// fait monter une ligne dans la liste
  var
  i:integer;
  S1:string;
 begin
  with StringGrid1 do
  begin
   if Row<2 then  exit;
   for i:=1 to 6 do
   begin
    S1:= cells[i,Row];
    cells[i,Row]:= cells[i,Row-1];
    cells[i,Row-1]:=S1;
   end;
   Row:=Row-1;
  end;
end;


procedure TForm1.StringGrid1_down;
// fait descendre une ligne dans la liste
  var
  i:integer;
  S1:string;
 begin
  with StringGrid1 do
  begin
   if Row > RowCount-2 then exit;
   for i:=1 to 6 do
   begin
    S1:= cells[i,Row];
    cells[i,Row]:= cells[i,Row+1];
    cells[i,Row+1]:=S1;
   end;
   Row:=Row+1;
  end;
 end;


Procedure SansAccents(var s1:string);
begin
  while Pos('â', s1) > 0 do s1[Pos('â',s1)] := 'a';
  while Pos('à', s1) > 0 do s1[Pos('à',s1)] := 'a';
  while Pos('é', s1) > 0 do s1[Pos('é',s1)] := 'e';
  while Pos('è', s1) > 0 do s1[Pos('è',s1)] := 'e';
  while Pos('ê', s1) > 0 do s1[Pos('ê',s1)] := 'e';
  while Pos('ë', s1) > 0 do s1[Pos('ë',s1)] := 'e';
  while Pos('ï', s1) > 0 do s1[Pos('ï',s1)] := 'i';
  while Pos('î', s1) > 0 do s1[Pos('î',s1)] := 'i';
  while Pos('ô', s1) > 0 do s1[Pos('ô',s1)] := 'o';
  while Pos('ù', s1) > 0 do s1[Pos('ù',s1)] := 'u';
  while Pos('ç', s1) > 0 do s1[Pos('ç',s1)] := 'c';
end;


 procedure TForm1.Affiche_RA_sexa(nb_secondes: integer);
var
  h, mn, sec      : byte;
  R1             : integer;
  signe          : string;
begin
  signe:='+';
  h:= byte(nb_secondes div 3600);
  R1:= nb_secondes mod 3600;
  mn:= byte(R1 div 60);
  sec:= byte(R1 mod 60);
  Edit9.Text:= signe + intToStr(h) + ':' + intToStr(mn) + ':' + intToStr(sec);
end;


procedure TForm1.Affiche_DECLI_sexa(nb_secondes: integer);
// plus grande DECLI = 90*60*60 = 324000 secondes d'arc
// plus petite DECLI = -90° = -324000 secondes d'arc
// Les DECLI negatives sont enregistrees en positif en complément à 2
var
  d, mn, sec      : byte;
  R1             : integer;
  signe          : string;
begin
  if nb_secondes > 324000 then
  begin
   nb_secondes := nb_secondes - 324000;
   signe:= '-';
  end
  else signe:= ' ';
  d:= byte(nb_secondes div 3600);
  R1:= nb_secondes mod 3600;
  mn:= byte(R1 div 60);
  sec:= byte(R1 mod 60);
  Edit10.Text:= signe + intToStr(d) + ':' + intToStr(mn) + ':' + intToStr(sec);
end;


procedure TForm1.constitution_message(num_objet:integer);
var
 st1, st2:string;
begin
 st1:='00' + IntToStr(num_objet);
 st1:= copy(st1, length(st1) -1, 2); // formatage du texte '00', '01', '02', .. '50'

 st2:='000' + Edit5.text;
 st2:= copy(st2, length(st2) -2, 3); // formatage du texte '00', '01', '02', .. '50'

 nom_Objet:=Edit6.Text + '----------';
 nom_Objet:=copy(nom_Objet, 1, 10); // le nom comporte exactement 10 caracteres (avec de '-' à la fin)
 message1:=st1  +'_' + 'R' + Edit2.Text + 'D' + Edit3.Text + '_' + nom_Objet + '_'+ st2;
 Edit1.Text:=message1;
 Edit4.Text:=  IntToStr(length(Edit1.Text));
end;


procedure TForm1.EditClick(Sender: TObject);
begin

end;


procedure Tform1.detecte_expression(txti:string; L:integer);
//detecte la ligne contenant une expression donnée dans le teste copié depuis le presse-papier
//et inscrit le numéro de la ligne concernée et son contenu dans le StringGrig2
var
 li:integer;
 ligne_i:string;
 ok:boolean;
begin
  li:=-1;
  ok:=false;
  repeat
  inc(li);
  ligne_i:=Memo1.Lines[li];
  if pos(txti,ligne_i)<>0 then
   begin
    StringGrid2.Cells[0,L]:=IntToStr(li);
    StringGrid2.Cells[1,L]:=ligne_i;
    ok:=true;
   end;
  until (li=Memo1.Lines.Count) or ok;
end;


procedure TForm1.efface_cadre_saisie;
begin
  Edit2.Text:='';
  Edit3.Text:='';
  Edit6.Text:='';
  Edit7.Text:='';
  Edit8.Text:='';
  Edit9.Text:='';
  Edit10.Text:='';
  Edit20.Text:='';
  Edit13.Text:='';
  StringGrid2.Clean;
end;


procedure TForm1.decoder_CdC;
var
 str1,texte1,texte2:string;
 x1,p1,p2,i,lg1:integer;

begin
  objet_valide:=false;
  Memo1.clear;
  RA:=0;   DECLI:=0;
  Memo1. PasteFromClipboard;
  efface_cadre_saisie;
  signeD:='+';
  detecte_expression('Nom commun',0);
  detecte_expression('AR:',1);
  detecte_expression('Magnitude',2);
  Edit20.text:=Memo1.lines[0]; // type de l'objet
  str1:= StringGrid2.Cells[1,0];

  if str1<>'' then
   begin
    x1:=pos('Nom commun',str1);
    Edit6.Text:=copy(str1,x1+12,10);
   end
   else Edit6.Text:=copy(Memo1.Lines[1],1,10);

  str1:= StringGrid2.Cells[1,2];
  if str1<>'' then
   begin
    x1:=pos(':',str1); // le ":" à la fin de "Magnitude visuelle"
    Edit8.Text:=copy(str1,x1+2,5);
   end;

//constellation
   lg1:=length(Edit6.Text);
   Edit7.Text:=copy(Edit6.Text,lg1-2,3);
   decodage_abrev_constell;

// decodage RA
   texte1:= StringGrid2.Cells[1,1];
   p1:=pos('AR:',texte1);

   if p1<>0 then
    begin
     i:=p1;
     while (texte1[i]<>'h') and (i<length(texte1)) do inc(i);
     texte2:=copy(texte1,i-3,3);
     RAih:=StrToInt(texte2);
     while (texte1[i]<>'m') and (i<length(texte1)) do inc(i);
     texte2:=copy(texte1,i-2,2);
     RAimn:=StrToInt(texte2);
     while (texte1[i]<>'.') and (i<length(texte1)) do inc(i);
     texte2:=copy(texte1,i-2,2);
     RAis:=StrToInt(texte2);
     Edit9.text:=IntToStr(RAih)+'h'+IntToStr(RAimn)+'m'+IntToStr(RAis)+'s';
     RA:= RAis + 60 * RAimn + 3600 * RAih;
     txt_RA:= '00000' + IntToStr(RA);
     txt_RA:=copy(txt_RA, length(txt_RA)-4, 5); // le string RA contient exactement 5 caracteres (avec des 0 devant)
     Edit2.Text:=txt_RA;  // AffichageEtendu en secondes; plus grand AffichageEtendu = '86400' (5 caract)
    end;

// decodage DEC
   texte1:= StringGrid2.Cells[1,1];
   p1:=pos('DE:',texte1);
   p2:=pos('°',texte1);
   if (p1<>0) and (p2<>0) and (p2>p1) then
   begin            //rappel: exemple: AR: 18h37m17.754s DE:+38°47'42.99"
    texte2:=copy(texte1,p2-2,2); // '38'
    signeD:='+'; // à priori
    if pos('-',texte2) <> 0 then  signeD:='-';
    DECid:=abs(StrToInt(texte2));
    texte2:=copy(texte1,p2+2,2);
    DECimn:=StrToInt(texte2);
    texte2:=copy(texte1,p2+5,2);
    DECis:=StrToInt(texte2);
    Edit10.text:=IntToStr(DECid)+'º'+IntToStr(DECimn)+'m';
    DECLI:= DECis + 60 * DECimn + 3600 * DECid;
    if  signeD='-' then DECLI:= -DECLI;
    txt_DECLI:='0000000' +IntToStr(DECLI);  // AffichageEtendu en secondes; plus grand AffichageEtendu = '-324000' (7 caract)
    txt_DECLI:=copy(txt_DECLI, length(txt_DECLI)-6, 7); // le string DECLI5 contient exactement 7 caracteres (avec des 0 devant)
    Edit3.Text:=txt_DECLI;
    objet_valide:=true;
   end;

   if objet_valide then constitution_message(StringGrid1.Row)
   else
    begin
     efface_cadre_saisie;
    end;
end;


procedure OutString232(sti:string); // sortie message de longueur constante (avec des '-' à la fin le cas echeant)
 var
  i, nb_car :integer;
begin
  if port_serie_ouvert then
  begin
    sti:=sti + chr(10); // saut de ligne
    for i:=1 to nb_caract_232 do  sti:=sti+'-';
    sti:= copy(sti, 1, nb_caract_232);
    for i:=1 to nb_caract_232 do RS232Buffer_out[i]:= byte(sti[i]);
    nb_car:=nb_caract_232;
  end
  else showmessage('Choisir le port série au préalable');

  SerWrite(Handle_port_serie, RS232Buffer_out[1],nb_car);

end;




procedure TForm1.MenuCloseClick(Sender: TObject);
begin
 port_serie_ouvert:=false;
 SerClose(Handle_port_serie);
 Led_USB1.brush.Color:=clgray;
 Led_USB2.brush.Color:=clgray;
end;


procedure TForm1.MenuOpenClick(Sender: TObject);
begin
 Form2.Visible:=true;
end;


procedure TForm1.Port_serieClick(Sender: TObject);
begin

end;


procedure TForm1.Envoi_Message(cmd:string);
begin
  Led_USB2.brush.Color:=clyellow;
  Edit1.Text:= cmd + message1;  // message1 est généré par la procédure "constitution_message"
  try Edit4.Text:=  IntToStr(length(Edit1.Text));
  except exit;
  end;
  Memo3.Lines.Add('envoi: ' + Edit1.Text);
  OutString232(Edit1.Text + ';'); // J'utilise le ; comme octet de fin de message
  // les octets de service comme chr(10) et chr(13) ne m'ont causés que des ennuis!
end;






procedure TForm1.Bt_import_CdCClick(Sender: TObject);
begin
  decoder_CdC;
end;


procedure TForm1.BitBt_UPClick(Sender: TObject);
begin
 StringGrid1_up;
end;


procedure TForm1.BitBtn_DOWNClick(Sender: TObject);
begin
  StringGrid1_down;
end;


procedure TForm1.recopie_1ligne_dans_cadre(num_ligne:integer);
var
 DECLI_txt: string;
 RA1, DECLI1 :integer;

begin
   Affiche_RA_sexa(0);
   Affiche_DECLI_sexa(0);
   Edit6.Text:=StringGrid1.Cells[1,num_ligne]; // Nom Objet
   Edit7.Text:=StringGrid1.Cells[4,num_ligne]; // Constellation
   Edit8.Text:=StringGrid1.Cells[5,num_ligne]; // Magnitude
   Edit2.Text:=StringGrid1.Cells[2,num_ligne]; // RA txt
   Edit3.Text:=StringGrid1.Cells[3,num_ligne]; // DECLI txt
   Edit5.text:=StringGrid1.Cells[6,num_ligne]; // Numéro Perso
   try
    RA1:= StrToInt(Edit2.Text);
    Affiche_RA_sexa(RA1);
   except objet_valide:=false; exit; end;

   DECLI_txt:=Edit3.Text;
   // efface les 0 non significatif
   if DECLI_txt<>'0' then while pos('0',DECLI_txt)=1 do DECLI_txt:= copy(DECLI_txt, 2,255);
   try
    DECLI1:= StrToInt(DECLI_txt);
    Affiche_DECLI_sexa(DECLI1);
   except objet_valide:=false; exit; end;
   decodage_abrev_constell;
   constitution_message(num_ligne);
   objet_valide:=true;
end;


procedure TForm1.StopClick(Sender: TObject);
begin
  Timer4_WriteRS232.Enabled:=false;
  ProgressBar1.Position:=0;
  OutString232('!N;');
end;


procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  CBox_Constellations.ItemIndex:=-1;
  recopie_1ligne_dans_cadre(StringGrid1.Row);
end;


procedure TForm1.AffichageEtenduClick(Sender: TObject);
begin
 if AffichageEtendu.Checked then
 begin
  Form1.Width:=largeur_maxi;
  Memo3.Visible:=true;
 end else
 begin
  Memo3.Visible:=false;
  Form1.Width:=largeur_mini;
 end;
end;


procedure TForm1.aide_generaleClick(Sender: TObject);
begin
  AProcess := TProcess.Create(nil);
  AProcess.CommandLine := 'gedit ./etoiles/aide_ape2009.txt';
// We will define an option for when the program
// is run. This option will make sure that our program
// does not continue until the program we will launch
// has stopped running.
  AProcess.Options := AProcess.Options + [poWaitOnExit];
  AProcess.Execute;
// This is not reached until ppc386 stops running.
  AProcess.Free;
end;


procedure TForm1.Aide_liaison_serieClick(Sender: TObject);
begin
  Form1.Width:=1000;
  Memo3.Visible:=true;
  Memo3.Clear;
  Memo3.text:='Nombre d''octets lus = 0 indique que le port choisi existe mais ne reçoit aucun signal;' + chr(10)+
  'Nombre d''octets lus = -1 en revanche indique que le port choisi n''est pas le bon';
end;

procedure TForm1.A_proposClick(Sender: TObject);
begin
  showmessage('APE 2009 version ' + version_i + chr(10)
  + 'copyleft 2009 - Silicium628' + chr(10)
  + 'logiciel libre' + chr(10)
  + 'sous licence GNU - GPL'
  );
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  StringGrid1.Rows[StringGrid1.Row].Clear;
end;


procedure TForm1.BitBtn3Click(Sender: TObject);
begin
 StringGrid1_top;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
 StringGrid1.Clean(1,1,7,StringGrid1.RowCount-1, [gzNormal]);
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
  StringGrid1_bottom;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
 Form1.Color:=clBlack;
 Memo1.Color:=clBlack ;
 Memo1.font.color:=clgray;
// Memo1.Ctl3D:=false;
 Panel1.Color:=clBlack;
 StringGrid1.Color:=clBlack;
 StringGrid1.font.color:=clMaroon;
 StringGrid2.Color:=clBlack;
 StringGrid2.font.color:=clMaroon;
 //Etat_USB.Color:=clBlack;
 //Etat_USB.Font.Color:=clMaroon;
 Edit1.Color:=clBlack;
 Edit1.Font.Color:=clMaroon;
 Edit2.Color:=clBlack;
 Edit2.Font.Color:=clMaroon;
 Edit3.Color:=clBlack;
 Edit3.Font.Color:=clMaroon;
 Edit4.Color:=clBlack;
 Edit4.Font.Color:=clMaroon;
 Edit6.Color:=clBlack;
 Edit6.Font.Color:=clMaroon;
 Edit7.Color:=clBlack;
 Edit7.Font.Color:=clMaroon;
 Edit8.Color:=clBlack;
 Edit8.Font.Color:=clMaroon;
 Edit10.Color:=clBlack;
 Edit10.Font.Color:=clMaroon;
 Edit20.Color:=clBlack;
 Edit20.Font.Color:=clMaroon;
 UpDown1.Color:=clBlack;
 UpDown1.Font.Color:=clMaroon;
 Edit13.Color:=clBlack;
 Edit13.Font.Color:=clMaroon;
 CBox_Constellations.Color:=clBlack;
 CBox_Constellations.Font.Color:=clMaroon;
 Edit9.Color:=clBlack;
 Edit9.Font.Color:=clMaroon;
end;



 procedure TForm1.decodage_abrev_constell;
var
 i1,n1,lg1:integer;
 texte4, texte5:string;
begin
 i1:=0;
 n1:=4;
 texte4:='';
 texte5:='';
 texte5:= LowerCase(copy(Edit7.Text,1,n1));
 SansAccents(texte5);
 if  (texte5='peti') then
 begin
   n1:=9; texte5:= LowerCase(copy(Edit7.Text,1,n1));
   SansAccents(texte5);
 end;
 if  (texte5='cour')then
 begin
   n1:=15;texte5:= LowerCase(copy(Edit7.Text,1,n1));
   SansAccents(texte5);
 end;
 while (texte4 <> texte5 ) and (i1<88) do
   begin
    inc(i1);
    CBox_Constellations.ItemIndex:=i1;
    texte4:= LowerCase(CBox_Constellations.Text);
    lg1:=length(texte4);
    texte4:=copy(texte4,lg1-2, 255);
    SansAccents(texte4);
   end;
   if i1=88 then Edit7.Text:='===';
end;


Function SansZero(txt_i:string):string;
//supprime les zéros non significatifs
var txt2:string;
begin
 txt2:= txt_i;
 {
 if pos('=',txt2)<>0 then
  begin
   txt2:='0';
   SansZero:='0';
   exit;
  end;
}
 // suppression des 0 non significatifs au debut
 if txt2<>'0' then while pos('0',txt2)=1 do txt2:= copy(txt2, 2,255);
 SansZero:=txt2;
end;


function is_numeric(sti:string): boolean;
var
 lg1,i:integer;
begin
 if sti='' then
 begin
  result:=false;
  exit;
 end;
 result:=true;
 lg1:=length(sti);
 for i:= 1 to lg1-1 do
  begin
   if  not (((sti[i]) in ['0'..'9'])
   or (sti[i]='.')  // nombres décimaux
   or (sti[i]=',')  // autre notation du séparateur décimal
   or (sti[i]='-')) // nombres négatifs
   then  result:=false;
  end;
end;



procedure TForm1.StringGrid1_tri_numerique(col_i:integer);
// tri par bulle de 7 colonnes en fonction du contenu de la colonne numero 'col_i'
// tri correctement les strings representant une valeur numerique
var
 s1,s2:string;
 s11,s12,s21,s22,s31,s32,s41,s42,s51,s52,s61,s62,s71,s72:string;
 n,i:integer;
 nb_lignes:integer;

begin
 case Radio_Tri.ItemIndex of
 0: nb_lignes:=50;  // nb de lignes à trier
 1: nb_lignes:=200;
 end;

  with StringGrid1 do
  begin
   for i:=1 to nb_lignes do
   begin
    n:=nb_lignes-1;
    repeat
     s1:=SansZero(cells[col_i,n]);
     s2:=SansZero(cells[col_i,n+1]);
     if pos('=',s1)<>0 then s1:='999999';
     if pos('=',s2)<>0 then s2:='999999';

     if is_numeric(s1) and is_numeric(s2) then
     begin
       S11:=cells[1,n];        S12:=cells[1,n+1];
       S21:=cells[2,n];        S22:=cells[2,n+1];
       S31:=cells[3,n];        S32:=cells[3,n+1];
       S41:=cells[4,n];        S42:=cells[4,n+1];
       S51:=cells[5,n];        S52:=cells[5,n+1];
       S61:=cells[6,n];        S62:=cells[6,n+1];
       S71:=cells[7,n];        S72:=cells[7,n+1];

     if StrToFloat(s1) > StrToFloat(s2) then
       begin
        cells[1,n+1]:=S11;    cells[1,n]:=S12;
        cells[2,n+1]:=S21;    cells[2,n]:=S22;
        cells[3,n+1]:=S31;    cells[3,n]:=S32;
        cells[4,n+1]:=S41;    cells[4,n]:=S42;
        cells[5,n+1]:=S51;    cells[5,n]:=S52;
        cells[6,n+1]:=S61;    cells[6,n]:=S62;
        cells[7,n+1]:=S71;    cells[7,n]:=S72;
       end;
     end;
      n:=n-1;
    until  n<=0;
   end;
// fin du tri
  end;
end;


 procedure TForm1.StringGrid1_trier(col_i:integer);
// tri par bulle de 7 colonnes en fonction du contenu de la colonne numero 'col_i'
var
 s1,s2:string;
 s11,s12,s21,s22,s31,s32,s41,s42,s51,s52,s61,s62,s71,s72:string;
 n,i:integer;
 nb_lignes:integer;
begin
 case Radio_Tri.ItemIndex of
 0: nb_lignes:=50;  // nb de lignes à trier
 1: nb_lignes:=200;
 end;

  with StringGrid1 do
  begin
   for i:=1 to nb_lignes do
   begin
    n:=nb_lignes-1;
    repeat
     S11:=cells[1,n];        S12:=cells[1,n+1];
     S21:=cells[2,n];        S22:=cells[2,n+1];
     S31:=cells[3,n];        S32:=cells[3,n+1];
     S41:=cells[4,n];        S42:=cells[4,n+1];
     S51:=cells[5,n];        S52:=cells[5,n+1];
     S61:=cells[6,n];        S62:=cells[6,n+1];
     S71:=cells[7,n];        S72:=cells[7,n+1];

     s1:=cells[col_i,n];
     s2:=cells[col_i,n+1];
     while pos('=',s1)<>0 do s1[pos('=',s1)]:='z';  // sinon les '=' se retrouvent en tête de liste
     while pos('=',s2)<>0 do s2[pos('=',s2)]:='z';

     if (s1 > s2)  then
     begin
      cells[1,n+1]:=S11;    cells[1,n]:=S12;
      cells[2,n+1]:=S21;    cells[2,n]:=S22;
      cells[3,n+1]:=S31;    cells[3,n]:=S32;
      cells[4,n+1]:=S41;    cells[4,n]:=S42;
      cells[5,n+1]:=S51;    cells[5,n]:=S52;
      cells[6,n+1]:=S61;    cells[6,n]:=S62;
      cells[7,n+1]:=S71;    cells[7,n]:=S72;
     end;

     n:=n-1;
    until  n=0;
   end;
// fin du tri
  end;
end;


procedure TForm1.StringGrid1_calcul_distance;
{calcul des distances angulaires à l'objets selectionné
ds2:=dx2 + dy2;
puis trie le tout
}
const
 nb_lignes=200;
var
 ligne0:integer;
 RA_txt,DECLI_txt:string;
 RA0, RAi, DECLI0, DECLIi: real;
 i:byte;
begin
   ligne0:=StringGrid1.Row;
   RA_txt:= SansZero(StringGrid1.Cells[2,ligne0]);
   DECLI_txt:= SansZero(StringGrid1.Cells[3,ligne0]);
   if is_numeric(RA_txt) and is_numeric(DECLI_txt) then
    begin
     RA0:= StrToInt(RA_txt);
     DECLI0:= StrToInt(DECLI_txt);
    end else
    begin
     showmessage('Ligne vide (ou données de l''objet choisi non conformes)');
     exit;
    end;

   i:=1;
   repeat
     RA_txt:=SansZero(StringGrid1.Cells[2,i]);
     DECLI_txt:=SansZero(StringGrid1.Cells[3,i]);
     if is_numeric(RA_txt) and is_numeric(DECLI_txt) then
      begin
       RAi:= StrToInt(RA_txt);
       DECLIi:=StrToInt(DECLI_txt);
       StringGrid1.Cells[7,i]:= floatToStr( INT((sqr(15*(RA0-RAi)) + sqr(DECLI0-DECLIi))/1E6 ));
      end
     else
      begin
        StringGrid1.Cells[7,i]:='999999';
      end;
{ 90 deg de decli  = 90*60*60 s = 324 000 s
  90 deg de RA = 6h = 6*60*60 s =  21 600 s
  Le rapport entre les deux est de 15 c.a.d qu'il faut 15s de temps pour parcourir une distance angulaire de 15 d'arc
  d'ou le coefficient ci-dessous; le 1E6 sert juste a ne pas afficher de nombres trop grands inutilement}

     inc(i);
    until i=nb_lignes;
  StringGrid1_tri_numerique(7);
end;


procedure TForm1.EnfonceBouton(n:integer);
// représente le bouton 'n' enfoncé et relache les autres. Si n=0, relache tous les boutons.
begin
 if n=2 then Button2.Color:=ClSilver else Button2.Color:=ClBtnFace;
 if n=3 then Button3.Color:=ClSilver else Button3.Color:=ClBtnFace;
 if n=4 then Button4.Color:=ClSilver else Button4.Color:=ClBtnFace;
 if n=5 then Button5.Color:=ClSilver else Button5.Color:=ClBtnFace;
 if n=6 then Button6.Color:=ClSilver else Button6.Color:=ClBtnFace;
 if n=7 then Button7.Color:=ClSilver else Button7.Color:=ClBtnFace;
 if n=8 then Button8.Color:=ClSilver else Button8.Color:=ClBtnFace;
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
 EnfonceBouton(2);
 StringGrid1_trier(1);  //NOM
end;


procedure TForm1.Button3Click(Sender: TObject);
begin
 EnfonceBouton(3);
 StringGrid1_tri_numerique(2);  //RA
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 EnfonceBouton(4);
 StringGrid1_tri_numerique(3); //DECLI
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 EnfonceBouton(5);
 StringGrid1_trier(4); //CONSTELLATION
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 EnfonceBouton(6);
 StringGrid1_tri_numerique(5); //MAGNITUDE
end;


procedure TForm1.Button7Click(Sender: TObject);
begin
 EnfonceBouton(7);
 StringGrid1_tri_numerique(6);  //NUMERO PERSO
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  EnfonceBouton(8);
  StringGrid1.Cells[7,0]:= 'dist.°'; //DISTANCE ANGULAIRE
  StringGrid1_calcul_distance;
  StringGrid1.Row:=1;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  Edit9.text:='12:00:00';
  Edit10.text:='90:00:00';
  encode_RA;
  encode_DEC;
end;




procedure TForm1.Charger_fichier(nom_fichier1:string);
{ lit un fichier sur le disque dur et:
-l'affiche dans StringGrid1
-le memorise dans Liste_objets1
 }
var
  fichier1:TextFile;
  ok:boolean;
  txt_ligne: string;
  i:integer;
  nom1,RAtxt,DECLItxt:string;
begin

  ok:=true;
//   Edit8.Text:=OpenDialog1.FileName;
  AssignFile(fichier1,nom_fichier1 );
  reset(fichier1);

  readln(fichier1, txt_ligne); //ignore les 2 premieres lignes du fichier (commentaires)
  readln(fichier1, txt_ligne);
  i:=1;
  while ((not eof(fichier1)) and (i<=nbr_ast)) do
  begin
    StringGrid1.Rows[i].Clear;
    readln(fichier1, txt_ligne);
// exemple d'une ligne conforme:  !E001_R51363D0068919_ARCTURUS-- Boo 0.04 01

    if (copy(txt_ligne,1,2)<>'!E') or (txt_ligne[7]<>'R') or (txt_ligne[13]<>'D') or (txt_ligne[21]<>'_') then
      begin
// !E001_R51363D0068919_ARCTURUS--_Boo_0.04_01
// 0000000001111111111222222222233333333334444
// 1234567890123456789012345678901234567890123
//                 !E001_R51363D0068919_ARCTURUS--_Boo_0.04_01
       txt_ligne:='!E000_R00000D0000000_==========_===_====_==';
       ok:=false;
      end;

    StringGrid1.Cells[0,i]:=IntToStr(i);
    nom1:= copy(txt_ligne,22,10);
    if pos('-',nom1)<>0 then nom1:=copy(nom1,1,pos('-',nom1)-1);
    StringGrid1.Cells[1,i]:=nom1;
    RAtxt:= copy(txt_ligne,8,5);
//    while pos('0',RAtxt)=1 do RAtxt:= copy(RAtxt, 2,255); // suppression des 0 non significatifs au debut
    if RAtxt<>'' then StringGrid1.Cells[2,i]:=RAtxt;
    DECLItxt:= copy(txt_ligne,14,7);
//    while pos('0',DECLItxt)=1 do DECLItxt:= copy(DECLItxt, 2,255);
    if DECLItxt<>'' then StringGrid1.Cells[3,i]:=DECLItxt;
    StringGrid1.Cells[4,i]:=copy(txt_ligne,33,3);
    StringGrid1.Cells[5,i]:= copy(txt_ligne,37,4);
    StringGrid1.Cells[6,i]:= copy(txt_ligne,42,3);
    inc(i);
   end;

   CloseFile(fichier1);
   if not ok then showmessage('Certaines lignes du fichier étant non conformes, elles ont été remplacées');

 EnfonceBouton(0);
 fichier_etoiles_ok:= true;
 form1.caption:='APE2009 - ' +version_i  + ' - ' + nom_fichier1 ;

end;


procedure TForm1.Timer4_WriteRS232Timer(Sender: TObject);
// Envoi les données vers l'ATmega par la liaison série USB-rs232
begin
  inc(num_objet);
  if  num_objet <= 50 then    // =5 pour TEST; sinon =50  ***********************
  begin
    recopie_1ligne_dans_cadre(num_objet);
    ecrire_EEPROMClick(self);
    ProgressBar1.Position:= num_objet;
  end
  else
   begin
    Timer4_WriteRS232.Enabled:=false;
    ProgressBar1.Position:=0;
    Led_USB2.brush.Color:=clgray;
    Envoi_Message('!N'); // repasse l'ATmega en mode Normal
    Showmessage('Données transmises en EEPROM');
  end;

end;


procedure TForm1.WR_EEPROMClick(Sender: TObject);
begin
 OutString232('!W;');
end;


procedure TForm1.ChargerClick(Sender: TObject);
begin
 OpenDialog1.InitialDir:=CurrentRept;
 if OpenDialog1.Execute then Charger_fichier(OpenDialog1.FileName);
end;


procedure TForm1.ecrire_EEPROMClick(Sender: TObject);
//ecrit l'objet contenu dans le cadre de gauche dans l'EEPROM de l'APE
begin
 if port_serie_ouvert then
 begin
   if objet_valide then
   begin
    Edit11.Text:='TRANSFERT';
    Edit11.Font.Color:=clgreen;
    Led_USB2.brush.Color:=clyellow;
//  Timer3_1s.Enabled:=true;
    Envoi_Message('!E');
//  StringGrid1.Clear;
//  Screen.Cursor:= crHourGlass;
   end
   else showmessage('Cadre vide ou objet non valide' + chr(10)
 + 'Utilisez le bouton fléché pour copier 1 objet de la liste dans le cadre');
 end  else showmessage('Choisir le port série au préalable');
end;




procedure TForm1.Ecrire_plusieurs_objetsClick(Sender: TObject);
 begin
  if fichier_etoiles_ok then
  begin
    if port_serie_ouvert then
     begin
       Memo3.Lines.Add('Seuls les 50 premières lignes seront écrites dans l''EEPROM de l''ATméga');
       Memo3.Lines.Add('-----------------------');
       showmessage('Placez l''APE en mode TRANSFERT puis cliquez sur OK');
       num_objet:=0;
       Timer4_WriteRS232.Enabled:=false;  //pour RAZ le timer
       Timer4_WriteRS232.Enabled:=true;
     end  else showmessage('Choisir le port série au préalable');
   end  else showmessage('Charger un fichier d''objets au préalable');
 end;


procedure TForm1.Edit10EditingDone(Sender: TObject);
begin
  encode_DEC;
end;



procedure TForm1.Edit13Change(Sender: TObject);
var
 i:integer;
begin
 i:=StringGrid1.row;
 StringGrid1.Cells[6,i]:= Edit13.Text;
end;


procedure TForm1.encode_RA;
var
 txt0,txt1,txt2,txt3:string;
 p1,p2:integer;

begin
//14:16:3
//on va decouper le texte en 3 tronçons  '14' , '16' et '3'
   txt0:= Edit9.Text;
   p1:=pos(':',txt0);
   txt1:=copy(txt0,0,p1-1); // '14'
   txt0:= copy(txt0, p1+1,255); // on coupe le début
   p2:=pos(':',txt0);
   txt2:= copy(txt0,0,p2-1); // '8' remarque: ok quel que soit le nb de chiffres
   txt0:= copy(txt0, p2+1,255); // on coupe le début
   txt3:=txt0;   // le compilateur simplifiera!

 //  Memo3.Lines.Add(txt1 +'z' + txt2 +'z' +txt3); // pour test
   RAih:=abs(StrToInt(txt1));
   RAimn:=StrToInt(txt2);
   RAis:=StrToInt(txt3);
   RA:= RAis + 60 * RAimn + 3600 * RAih;
   txt_RA:='00000' +IntToStr(RA);  // AffichageEtendu en secondes; plus grand AffichageEtendu = '-324000' (7 caract)
   txt_RA:=copy(txt_RA, length(txt_RA)-4, 5); // le string DECLI5 contient exactement 7 caracteres (avec des 0 devant)
   Edit2.Text:=txt_RA;
 end;


procedure TForm1.encode_DEC;
var
 txt0,txt1,txt2,txt3:string;
 p1,p2:integer;

begin
//19:8:39
//on va decouper le texte en 3 tronçons  '19' , '8' et '39'
   txt0:= Edit10.Text;
   Memo3.Lines.Add(txt0);
   p1:=pos(':',txt0);
   txt1:=copy(txt0,0,p1-1); // '19'
   signeD:='+'; // à priori
   if pos('-',txt0) <> 0 then  signeD:='-';
   txt0:= copy(txt0, p1+1,255); // on coupe le début
   p2:=pos(':',txt0);
   txt2:= copy(txt0,0,p2-1); // '8' remarque: ok quel que soit le nb de chiffres
   txt0:= copy(txt0, p2+1,255); // on coupe le début
   txt3:=txt0;   // le compilateur simplifiera!

   DECid:=abs(StrToInt(txt1));
   DECimn:=StrToInt(txt2);
   DECis:=StrToInt(txt3);
   DECLI:= DECis + 60 * DECimn + 3600 * DECid;
   if  signeD='-' then DECLI:= -DECLI;
   txt_DECLI:='0000000' +IntToStr(DECLI);  // AffichageEtendu en secondes; plus grand AffichageEtendu = '-324000' (7 caract)
   txt_DECLI:=copy(txt_DECLI, length(txt_DECLI)-6, 7); // le string DECLI5 contient exactement 7 caracteres (avec des 0 devant)
   Edit3.Text:=txt_DECLI;
end;


procedure TForm1.Edit9EditingDone(Sender: TObject);
begin
 encode_RA;
end;





procedure TForm1.EnregistrerClick(Sender: TObject);
var
 nom1:string;
 st1:string;
 ligne1:string;
 fichier1:TextFile;
 i:integer;
 DECLI_txt: string;
 DECLI1 :integer;
begin
  if SaveDialog1.Execute then
   begin
    nom1:= SaveDialog1.FileName;
    if pos('.etl',nom1)=0 then nom1:=nom1+'.etl';
    AssignFile(fichier1, nom1);
    rewrite(fichier1);
{
les 2 premieres lignes sont des commentaires en entete du fichier texte sur le disque dur.
Ces commentaires ne sont pas interpretes ulterieurement par ce logiciel, qui ignore les 2 premires lignes.
}
    writeln(fichier1,'Liste d''objets astronomiques pour le logiciel APE2009');
    writeln(fichier1,'Les positions sont donnees en secondes (de temps pour RA et d''arc pour DECLI)');
{rappel format:
!E001_R51363D0068919_ARCTURUS--_Boo_0.04_01
0000000001111111111222222222233333333334444
1234567890123456789012345678901234567890123
}
    for i:=1 to 200 do
     begin
      st1:='000' + IntToStr(i);
      st1:= copy(st1, length(st1) -2, 3);
      nom_Objet:=StringGrid1.Cells[1,i] + '----------';
      nom_Objet:=copy(nom_Objet, 1, 10); // le nom comporte exactement 10 caracteres (avec de '-' à la fin)
      nom_cstl:= StringGrid1.Cells[4,i];
      nom_cstl:= copy(nom_cstl, 1, 3);
      txt_RA:=StringGrid1.Cells[2,i];
      if pos('=',txt_RA)>0 then txt_RA:='0';
      txt_RA:= '00000' + txt_RA;
      txt_RA:=copy(txt_RA, length(txt_RA)-4, 5);
//      txt_DECLI:='0000000' + StringGrid1.Cells[3,i];
      DECLI_txt:=StringGrid1.Cells[3,i];
   // efface les 0 non significatifs
      if pos('=',DECLI_txt)>0 then DECLI_txt:='0';
      while ((DECLI_txt<>'0') and (pos('0',DECLI_txt)=1)) do DECLI_txt:= copy(DECLI_txt, 2,255);
      DECLI1:= StrToInt(DECLI_txt);
      if  DECLI1<0 then DECLI1:=324000 - DECLI1;  // pas de signe (-) dans les fichiers texte!
      txt_DECLI:=IntToStr(DECLI1);
      txt_DECLI:= '0000000' + txt_DECLI;
      txt_DECLI:=copy(txt_DECLI, length(txt_DECLI)-6, 7);
      ligne1:= '!E' + st1 +'_' + 'R' + txt_RA + 'D'  + txt_DECLI + '_'
      + nom_Objet +'_'+nom_cstl + '_' + StringGrid1.Cells[5,i]+ '_' + StringGrid1.Cells[6,i];

      writeln(fichier1, ligne1);
     end;
    CloseFile(fichier1);
   end;
end;

// procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
procedure TForm1.FormClose(Sender: TObject);
begin
  if port_serie_ouvert then SerClose(Handle_port_serie);
end;


procedure TForm1.BitBt_copie_in_grilleClick(Sender: TObject);
{Recopie l'objet decodé
-dans le StringGrid1
-dans la Liste_Objets1
}
var
 i:byte;
 cstl1:string;
begin
 if objet_valide then
 begin
   i:=StringGrid1.Row;
   StringGrid1.Cells[1,i]:=Edit6.Text;              //nom
   StringGrid1.Cells[2,i]:= Edit2.Text;             //RA
   StringGrid1.Cells[3,i]:=Edit3.Text;              //decli
   cstl1:= CBox_Constellations.Text;                //
   cstl1:=copy(cstl1, length(cstl1)-2, 3);
   StringGrid1.Cells[4,i]:= cstl1;                  //constellation
   StringGrid1.Cells[5,i]:= Edit8.Text;             //magnitude
 end
 else showmessage('Objet non valide');
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  Memo3.Clear;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  OutString232('!T;');
end;



initialization
  {$I unit1.lrs}

end.

