#include <avr/io.h> 


AA	=	16
AL	=	17
AH	=	18
BL	=	19
BH	=	20
CL	=	21
CH	=	22

        .section .text


       	.global		RecvRC5

main:

fault1:
		CLR       AA
		RET

RecvRC5:                
		CBI       DDRD,7
		LDI       BH, 34

det0:                   
		SBIC      PIND, 7
		RJMP      det01
		LDI       AA, 0x006
                        CALL      uDelay
                        DEC       BH
                        BRNE      det0
                        RJMP      fault

det01:                  LDI       BL, 00CCBh AND 0x0FF
                        LDI       BH, 00CCBh SHRB 8

det1:                   CLR       AH

det2:                   LDI       AA, 0x004
                        CALL      uDelay
                        INC       AH
                        SBIW      BL, 1
                        BREQ      fault1

dl1:                    CPI       AH, 88
                        BRGE      startW
                        SBIS      PIND, 7
                        RJMP      det1
                        RJMP      det2

startW:                 LDI       AA, 0x004
                        CALL      uDelay
                        SBIW      BL, 1
                        BREQ      fault1
                        SBIC      PIND, 7
                        RJMP      startW
                        LDI       AH, 22

start1:                 LDI       AA, 0x004
                        CALL      uDelay
                        SBIW      BL, 1
                        BREQ      fault1
                        DEC       AH
                        BREQ      start2
                        SBIS      PIND, 7
                        RJMP      start1

start2:                 CLR       CL
                        LDI       CH, 13
                        CLR       AL
                        CLR       AH

sample:                 LDI       AA, 0x004
                        CALL      uDelay
                        INC       CL
                        CPI       CL, 11
                        BRLO      sample
                        SBIC      PIND, 7
                        RJMP      is1

is0:                    LSL       AL
                        ROL       AH

is0a:                   LDI       AA, 0x004
                        CALL      uDelay
                        INC       CL
                        CPI       CL, 32
                        BRLT      saut1
                        RJMP      fault

saut1:                  SBIS      PIND, 7
                        RJMP      is0a
                        CLR       CL

is0b:                   LDI       AA, 0x004
                        CALL      uDelay
                        INC       CL
                        CPI       CL, 22
                        BRGE      is0c
                        SBIC      PIND, 7
                        RJMP      is0b

is0c:                   CLR       CL
                        RJMP      nextbit

is1:                    SEC
                        ROL       AL
                        ROL       AH

is1a:                   LDI       AA, 0x004
                        CALL      uDelay
                        INC       CL
                        CPI       CL, 32
                        BRGE      fault
                        SBIC      PIND, 7
                        RJMP      is1a
                        CLR       CL

is1b:                   LDI       AA, 0x004
                        CALL      uDelay
                        INC       CL
                        CPI       CL, 22
                        BRGE      is1c
                        SBIS      PIND, 7
                        RJMP      is1b

is1c:                   CLR       CL

nextbit:                DEC       CH
                        BRNE      sample
                        MOV       CL, AL
                        LSL       CL
                        ROL       AH
                        LSL       CL
                        ROL       AH
                        BST       AH, 5
                        BLD       AL, 6
                        ANDI      AH, 0x01F
                        ANDI      AL, 07Fh
                        LDD       CL, Y+0x000
                        LDD       CH, Y+0x001
                        ST        Z, AL
                        LDD       CL, Y+0x002
                        LDD       CH, Y+0x003
                        ST        Z, AH

exit:                   SER       AA
                        RET

fault:                  CLR       AA
                        RET
